"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$$deepEqual = void 0;
var tslib_1 = require("tslib");
var codegenValue = function (doc, code, r) {
    var e_1, _a;
    var rr = r;
    var type = typeof doc;
    var isPrimitive = doc === null || type === "boolean" || type === "string" || type === "number";
    if (isPrimitive) {
        if (doc === Infinity) {
            code.push("if(r" + r + " !== Infinity)return false;");
        }
        else if (doc === -Infinity) {
            code.push("if(r" + r + " !== -Infinity)return false;");
        }
        else {
            code.push("if(r" + r + " !== " + JSON.stringify(doc) + ")return false;");
        }
        return rr;
    }
    if (Array.isArray(doc)) {
        code.push("if(!Array.isArray(r" + r + ") || r" + r + ".length !== " + doc.length + ")return false;");
        for (var i = 0; i < doc.length; i++) {
            rr++;
            code.push("var r" + rr + "=r" + r + "[" + i + "];");
            rr = codegenValue(doc[i], code, rr);
        }
        return rr;
    }
    if (type === 'object' && doc) {
        var obj = doc;
        var keys = Object.keys(obj);
        code.push("if(!r" + r + " || typeof r" + r + " !== \"object\" || Array.isArray(r" + r + ") || Object.keys(r" + r + ").length !== " + keys.length + ")return false;");
        try {
            for (var keys_1 = tslib_1.__values(keys), keys_1_1 = keys_1.next(); !keys_1_1.done; keys_1_1 = keys_1.next()) {
                var key = keys_1_1.value;
                rr++;
                code.push("var r" + rr + "=r" + r + "[" + JSON.stringify(key) + "];");
                rr = codegenValue(obj[key], code, rr);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (keys_1_1 && !keys_1_1.done && (_a = keys_1.return)) _a.call(keys_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    }
    if (doc === undefined) {
        code.push("if(r" + r + " !== undefined)return false;");
        return rr;
    }
    return rr;
};
var $$deepEqual = function (a) {
    var code = [];
    codegenValue(a, code, 0);
    var fn = tslib_1.__spreadArray(tslib_1.__spreadArray([
        '(function(r0){'
    ], tslib_1.__read(code)), [
        'return true;',
        '})'
    ]);
    return fn.join('');
};
exports.$$deepEqual = $$deepEqual;
